#By: Benjamin Kibalo, March 2013
#code to send email notifications using Raspberry Pi

def emailer(to_addr, subject, file_path):
    import os
    import smtplib
    import string
    from email import Encoders
    from email.MIMEBase import MIMEBase
    from email.MIMEMultipart import MIMEMultipart
    from email.Utils import formatdate
    #this code is written with a gmail account in mina,d but it should work with any smtp server
    email_from = "username@gmail.com" #enter your username@gmail.com
    password = "yourpassword" #enter your google password
     
    msg = MIMEMultipart() #setup msg variable to contain email contents
    msg["From"] = email_from  
    msg["To"] = to_addr  #the to address (to_addr) is a variable in the function (see above) don't enter the actual value here
    msg["Subject"] = subject  #the subject of the email is a variable in the function (see above) don't enter the actual value here
    msg["Date"] = formatdate(localtime=True)  #include date and time info
    
    #the code block below sets up the email to send, including the attachment
    part = MIMEBase('application', "octet-stream")  
    part.set_payload( open(file_path, "rb").read())
    Encoders.encode_base64(part)
    part.add_header('Content-Disposition','attachment; filename="%s"' % os.path.basename(file_path))  #the file_path is provided when the function is called, do not add specifics here
    msg.attach(part)  #attach our file to the email
    
    try:   #this is exception handling, running try: xyz will attempt to send the email.  If there is an error the entire script won't stop, it will just skip to the except: portion
        server = smtplib.SMTP("smtp.gmail.com",587)  #using the gmail smtp server, port 587.  Feel free to update with any other smtp server info - this should work fine
        server.ehlo()
        server.starttls()
        server.ehlo
        server.login(email_from,password)  #loging to smtp server
        server.sendmail(email_from, to_addr, msg.as_string())  #send email using smtp server

        print("notification email sent to " + to_addr)  #send a message to the console than an email was sent to to_addr
        server.quit() #close the email server connection
        return 0

    except:
        print("Error sending email!")  #in the event something went wrong, we will print an error on the console, but the master script will keep running
        return 1
