#By: Benjamin Kibalo, March 2013
#code to update a google documents spreadsheet using Raspberry Pi

def gdoc_update(data, row):
    import gspread
    import datetime
   
    uname = "username@gmail.com" #you will need a google account to use google docs, enter your username here
    pword = "google password" #input your google password here
    logfile_sprdsht = "name_of_your_spreadsheet" #this should all be one word, I've had trouble using spaces in here, use underscores instead

    try:  #exception handling for updating the spreadsheet
        now = datetime.datetime.now()  #send current date/time to "now" variable
        gspr = gspread.login(uname, pword) #loging to google docs using the login info provided above

        spreadsheet = gspr.open(logfile_sprdsht) #open the specified spreadsheet
        worksheet = spreadsheet.sheet1 #switch to sheet1 (worksheet) of the spreadsheet
        worksheet.add_rows(1) #add a row (to the bottom), google spreadsheet limits the number of rows to about 400K, if this is an issues adjust your update time, if you don't add rows the default is 20
        #you will get constant errors if you are trying to add data to a row that doesn't exist.  This assures that there will always be "one more row"
        worksheet.update_cell(row+1, 1, now.strftime("%Y-%m-%d %H:%M"))  #update date/time info in row x column 1
        worksheet.update_cell(row+1, 2, data) #update temperature data in row x column 2

#note: you may see -1.XY temperature logged from time to time.  This is an issue with system resources.  If the pi is very busy it might not read the temperature sensor correctly and you will get a bogus
#value.  You can add conditional formatting to your spreadsheet to call these values out or add more code in the main script to cull out these bogus readings.  I see -1.27 as my error occasionally.
    
    except:
        print("Error with gspread, continuing...")  #in case of error, continue running the script and provide an error message to the console.

