#By: Benjamin Kibalo, March 2013
#code to get temperature information from DS1820 family of devices on Raspberry Pi

import os

def init_temp():
    #send the shell commands to inititate the hardware to interface with the DS1820
    os.system('modprobe w1-gpio') 
    os.system('modprobe w1-therm')

def temp_measure():
    device_dir = '/sys/bus/w1/devices/'  #directory for the bus
    device_ID = '10-0008004c05cc'        #subfolder/serial number associated with the DS1820
    device_file = device_dir + device_ID + '/w1_slave'  #concatenate the full directory
    
    try:
       	#read the temperature informaion
	f = open(device_file, 'r')  #set our DS1820 equal to a file called "f"
	temp_lines = f.readlines()  #read the lines of "f"
	f.close()                   #close "f"
    	
	#now interpret the information
	error_check = temp_lines[0].find('YES')  #make sure the reading is successful and "YES" is read
	temp_pos = temp_lines[1].find('t=')      #set the postiion to where "t=" is found so we can extract temperature data
	
        if error_check == -1:
            return 1      #send error (1) if "YES" is not found

        if temp_pos != -1:  #make sure the 't=' part is actually found first
            temp_celcius = temp_lines[1][temp_pos+2:] #move forward to the actual temp data
            temp_cel = float(temp_celcius) / 1000 # convert mili deg to deg, make sure to pass temp_celcius as float
            print('Temperature = ', temp_cel, ' deg C')  #print the data to the terminal
            return temp_cel	#return the temp_cel value to the calling function
 
        else:
            return 1

    except:
        return 1    #return an error if anything goes wrong, keep the script going

