#By: Benjamin Kibalo, March 2013
#code to toggle red and green LEDs on Raspberry Pi


import RPi.GPIO as GPIO

RED = 17   #set this to your software GPIO flag for the red LED
GRN = 27   #set this to your software GPIO flag for the green LED

def set_LED(color, state):
	GPIO.setwarnings(False)  #Calling set_LED as a function doesn't always release the pins, this avoids conflicts, run with this commented out first
	GPIO.setmode(GPIO.BCM)   #use BCM pin numbering
	GPIO.setup(GRN, GPIO.OUT) #set GRN LED pin to output
	GPIO.setup(RED, GPIO.OUT) #set RED LED pin to output
	if color == 'red':
		if state == 'on':
			GPIO.output(RED, True) #turn RED LED on
			return 0
		elif state == 'off':
			GPIO.output(RED, False) #turn RED LED off
			return 0
		else:
			return 1       #return an error if the input is not recognized
	elif color == 'green':
		if state == 'on':
			GPIO.output(GRN, True)  #turn GRN LED on
			return 0
		elif state == 'off':
			GPIO.output(GRN, False) #turn GRN LED off
			return 0
		else:
			return 1       #return an error if the input is not recognized
	else:
		return 1


